#include "search.h"
#include "winc.h"

void preferences(){}
void about(){}
void help(){}

void do_main_win (){

  radgrp_group = NULL;

  main_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  gtk_widget_set_usize(main_win, 850, 490);

  gtk_object_set_data (GTK_OBJECT (main_win), "main_win", main_win);
  gtk_container_set_border_width (GTK_CONTAINER (main_win), 4);
  gtk_window_set_title (GTK_WINDOW (main_win), "SFG");
  gtk_window_set_position (GTK_WINDOW (main_win), GTK_WIN_POS_CENTER);

  vbox1 = gtk_vbox_new (FALSE, 4);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_win), vbox1);

  menubar = gtk_menu_bar_new ();
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar, FALSE, TRUE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (menubar), GTK_SHADOW_NONE);

  preferences1 = gtk_menu_item_new_with_label ("Preferences");
  gtk_widget_ref (preferences1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "preferences1", preferences1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (preferences1);
  gtk_container_add (GTK_CONTAINER (menubar), preferences1);

  about1 = gtk_menu_item_new_with_label ("About");
  gtk_widget_ref (about1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "about1", about1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about1);
  gtk_container_add (GTK_CONTAINER (menubar), about1);

  help1 = gtk_menu_item_new_with_label ("Help");
  gtk_widget_ref (help1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "help1", help1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help1);
  gtk_container_add (GTK_CONTAINER (menubar), help1);

  hbox3 = gtk_hbox_new (FALSE, 4);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  frame3 = gtk_frame_new ("Arguments");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox3), frame3, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 3);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_ETCHED_OUT);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame3), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 4);

  root_e = gtk_entry_new ();
  gtk_widget_ref (root_e);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "root_e", root_e,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (root_e);
  gtk_table_attach (GTK_TABLE (table1), root_e, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  GTK_WIDGET_SET_FLAGS (root_e, GTK_CAN_DEFAULT);

  patt_e = gtk_entry_new ();
  gtk_widget_ref (patt_e);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "patt_e", patt_e,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (patt_e);
  gtk_table_attach (GTK_TABLE (table1), patt_e, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  label5 = gtk_label_new ("Root");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table1), label5, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  label4 = gtk_label_new ("Pattern");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table1), label4, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  hbox4 = gtk_hbox_new (FALSE, 4);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (hbox3), hbox4, TRUE, TRUE, 0);

  frame2 = gtk_frame_new ("Options");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox4), frame2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_ETCHED_OUT);

  vbox2 = gtk_vbox_new (FALSE, 4);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame2), vbox2);

  r_find = gtk_radio_button_new_with_label (radgrp_group, "Find");
  radgrp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (r_find));
  gtk_widget_ref (r_find);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "r_find", r_find,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r_find);
  gtk_box_pack_start (GTK_BOX (vbox2), r_find, TRUE, TRUE, 0);

  r_grep = gtk_radio_button_new_with_label (radgrp_group, "Grep");
  radgrp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (r_grep));
  gtk_widget_ref (r_grep);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "r_grep", r_grep,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (r_grep);
  gtk_box_pack_start (GTK_BOX (vbox2), r_grep, TRUE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (r_grep), TRUE);

  frame4 = gtk_frame_new ("Actions");
  gtk_widget_ref (frame4);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame4", frame4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (hbox4), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame4), GTK_SHADOW_ETCHED_OUT);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (frame4), fixed1);

  go_b = gtk_button_new_with_label ("Search!");
  gtk_widget_ref (go_b);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "go_b", go_b,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (go_b);

  gtk_fixed_put (GTK_FIXED (fixed1), go_b, 40, 48);
  gtk_widget_set_uposition (go_b, 40, 48);
  gtk_widget_set_usize (go_b, 62, 24);

  hbox2 = gtk_hbox_new (FALSE, 4);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  scrollwin1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrollwin1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "scrollwin1", scrollwin1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrollwin1);
  gtk_box_pack_start (GTK_BOX (hbox2), scrollwin1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  f_ctree = gtk_clist_new (2);
  gtk_widget_ref (f_ctree);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "f_ctree", f_ctree,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f_ctree);

  gtk_container_add (GTK_CONTAINER (scrollwin1), f_ctree);
  gtk_clist_set_column_width (GTK_CLIST (f_ctree), 0, 388);
  gtk_clist_set_column_width (GTK_CLIST (f_ctree), 1, 145);
  gtk_clist_column_titles_show (GTK_CLIST (f_ctree));

  label2 = gtk_label_new ("PATH");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (f_ctree), 0, label2);

  label3 = gtk_label_new ("FILE");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (f_ctree), 1, label3);

  frame5 = gtk_frame_new ("File details");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox2), frame5, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame5), GTK_SHADOW_ETCHED_OUT);

  table2 = gtk_table_new (4, 2, FALSE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame5), table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 4);

  label11 = gtk_label_new ("Mode");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_table_attach (GTK_TABLE (table2), label11, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label11), GTK_JUSTIFY_LEFT);

  label12 = gtk_label_new ("Last modify");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_table_attach (GTK_TABLE (table2), label12, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label12), GTK_JUSTIFY_LEFT);

  label10 = gtk_label_new ("Size");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_table_attach (GTK_TABLE (table2), label10, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);

  o_lab = gtk_label_new ("KillerLoop");
  gtk_widget_ref (o_lab);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "o_lab", o_lab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (o_lab);
  gtk_table_attach (GTK_TABLE (table2), o_lab, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (o_lab), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (o_lab), TRUE);

  s_lab = gtk_label_new ("Very Small");
  gtk_widget_ref (s_lab);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "s_lab", s_lab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_lab);
  gtk_table_attach (GTK_TABLE (table2), s_lab, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (s_lab), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (s_lab), TRUE);

  m_lab = gtk_label_new ("GPL!");
  gtk_widget_ref (m_lab);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "m_lab", m_lab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (m_lab);
  gtk_table_attach (GTK_TABLE (table2), m_lab, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  l_lab = gtk_label_new ("16:13:00 03 Oct 1999");
  gtk_widget_ref (l_lab);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "l_lab", l_lab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l_lab);
  gtk_table_attach (GTK_TABLE (table2), l_lab, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  label9 = gtk_label_new ("Owner");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_table_attach (GTK_TABLE (table2), label9, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_OUT);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame1), hbox1);

  label1 = gtk_label_new ("Status");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, TRUE, 10);
  gtk_misc_set_padding (GTK_MISC (label1), 7, 0);

  status_e = gtk_entry_new ();
  gtk_widget_ref (status_e);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "status_e", status_e,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_e);
  gtk_box_pack_start (GTK_BOX (hbox1), status_e, TRUE, TRUE, 0);
  gtk_entry_set_editable (GTK_ENTRY (status_e), FALSE);

  gtk_signal_connect (GTK_OBJECT (preferences1), "activate",
                      GTK_SIGNAL_FUNC (preferences),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about1), "activate",
                      GTK_SIGNAL_FUNC (about),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (help1), "activate",
                      GTK_SIGNAL_FUNC (help),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_win), "delete_event",
                      GTK_SIGNAL_FUNC (gtk_main_quit),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f_ctree), "select_row",
                      GTK_SIGNAL_FUNC (file_infos),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (go_b), "clicked",
                      GTK_SIGNAL_FUNC (go_search),
                      NULL);
  gtk_widget_grab_focus (root_e);
  gtk_widget_grab_default (root_e);
  gtk_widget_show(main_win);
}

